HDU 5501——The Highest Mark——————【贪心+dp】

The Highest Mark

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 630    Accepted Submission(s): 260


Problem Description
The SDOI in 2045 is far from what it was been 30 years ago. Each competition has t minutes and n problems.

The ith problem with the original mark of Ai(Ai106),and it decreases Bi by each minute. It is guaranteed that it does not go to minus when the competition ends. For example someone solves the ith problem after x minutes of the competition beginning. He/She will get AiBix marks.

If someone solves a problem on x minute. He/She will begin to solve the next problem on x+1 minute.

dxy who attend this competition with excellent strength, can measure the time of solving each problem exactly.He will spend Ci(Cit) minutes to solve the ith problem. It is because he is so godlike that he can solve every problem of this competition. But to the limitation of time, it's probable he cannot solve every problem in this competition. He wanted to arrange the order of solving problems to get the highest mark in this competition.
 

 

Input
There is an positive integer T(T10) in the first line for the number of testcases.(the number of testcases with n>200 is no more than 5)

For each testcase, there are two integers in the first line n(1n1000) and t(1t3000) for the number of problems and the time limitation of this competition.

There are n lines followed and three positive integers each line Ai,Bi,Ci. For the original mark,the mark decreasing per minute and the time dxy of solving this problem will spend.


Hint:
First to solve problem 2 and then solve problem 1 he will get 88 marks. Higher than any other order.
 

 

Output
For each testcase output a line for an integer, for the highest mark dxy will get in this competition.
 

 

Sample Input
1
4 10
110 5 9
30 2 1
80 4 8
50 3 2
 

 

Sample Output
88
 

 

Source
 
 
题目大意:n个问题,每个问题开始有个分值A,以及每分钟减少的分值B,解出该问题需要的时间C。问你在t分钟的时间内能得到的分值最多是多少。
 
解题思路:

这道题考察的是贪心思想和动态规划。

 

出题人中间可能是笔误,应该是  “如果此不等式不成立,那么应该交换这两项。“才对。或者我们假设此不等式成立,那么移项后发现(Bxi+1 / Cxi+1 <= Bxi / Cxi)也是应该按照(B/C)值从大到小的顺序选择。

 

#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<string>
#include<vector>
using namespace std;
typedef long long INT;
const int maxn = 1e5+200;
struct Problem{
    INT a,b,c;
}pros[maxn];
INT dp[maxn];
bool cmp(Problem aa,Problem bb){
    return (aa.b*1.0 / aa.c) > (bb.b*1.0 / bb.c);   // >
}
int main(){
    int n,t,T;
    while(T--){
        scanf("%d%d",&n,&t);
        memset(dp,0,sizeof(dp));
        for(int i = 1; i <= n; i++){
            scanf("%lld%lld%lld",&pros[i].a,&pros[i].b,&pros[i].c);
        }
        sort(pros+1, pros+1+n, cmp);
        for(int i = 1; i <= n; i++){
            for(int j = t; j >=pros[i].c ; j--){
                dp[j] = max(dp[j], dp[j-pros[i].c] + pros[i].a - (j * pros[i].b) );
            }
        }
        INT ans = dp[0];
        for(int i = 1; i <= t; i++){
            ans = max(ans, dp[i]);
        }
        printf("%lld\n",ans);
    }
    return 0;
}

  

posted @ 2015-10-19 12:48  tcgoshawk  阅读(225)  评论(0编辑  收藏  举报